"""
Sets: are good for checking if a value is in a set

value in Set:  fast operation (the cost does not
               depend on the number of elements in set)
               
value in List: slow operation: the cost increases as 
            we add more elements to the list
            
Set operations: union/intersection/difference

s1 & s2: intersection
s1 | s2: union
s1 - s2: difference

----> Looking up an index, does not work for sets
(lists are good for indexing, but not sets)


Dictionaries:

Keys that are any hashable value
Values can be anything
Addressable like lists


Keys are stored as sets, no order

Checking if a key exists is a set operation (constant time)

'tiger' in heights
True

Addressing a key that does not exist causes an
error

heights['skunk']
-> error

Dictionaries like lists are aliased on assignment
by default:

new_heights = heights
## new_heights is an alias, not a copy'


.keys() is an enumerator over keys
.values() is an enumerator over values
.items() is an enumerates over keys and values

"""

heights = dict()
heights['belgian horse'] = 162.6
heights['indian elephant'] = 280.0
heights['tiger'] = 91.0
heights['lion'] = 97.0

for key in heights.keys():
    print (key, heights[key])

print()

keys = list (heights.keys())
keys.sort()

for key in keys:
    print (key, heights[key])
    
print()

for key in sorted(heights.keys()):
    print (key, heights[key])
    
## values nn dictionaries can be changed
    
heights['lion'] = 100.0

## new keys can be added

heights['zebra'] = 90.0

print (list(heights.values() ))

for val in heights.values():
    print (val)


oh = dict()

oh['monday']= [('4PM-8PM','Amos Eaton 215'), ('8PM-10PM', 'CII 4050')]

oh['tuesday']= [('4PM-8PM','Amos Eaton 215'), ('8PM-10PM', 'CII 4050')]

oh['wednesday']= [('4PM-8PM','Sage 4101'), ('8PM-10PM', 'CII 4050')]

movies = dict()
movies['Hanks, Tom'] = {'The Terminal', 'Joe vs. Volcano'}